/**
 *
 *  Copyright Openmind http://www.openmindonline.it
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package net.sourceforge.openutils.mgnlcriteria.jcr.query.xpath.impl;

import info.magnolia.cms.core.Content;
import info.magnolia.cms.core.ItemType;
import info.magnolia.cms.core.search.QueryManager;
import net.sourceforge.openutils.mgnlcriteria.jcr.query.xpath.utils.XPathTextUtils;

import org.apache.commons.lang.StringUtils;


/**
 * @author fgrilli
 * @version $Id: AbstractMagnoliaCriteriaImpl.java 1600 2010-01-08 11:29:42Z fgiust $
 */
public abstract class AbstractMagnoliaCriteriaImpl extends AbstractCriteriaImpl
{

    protected info.magnolia.cms.core.search.QueryManager queryManager;

    /**
     * Constructor to be used by subclasses
     * @param path String - the path preceeding the predicate in the jcr query statement (you dont need to do escaping
     * yourself)
     * @param queryManager - an instance of {@link QueryManager}
     * @param itemType - String the itemType. Defaults to {@link ItemType#getSystemName#toString()}
     * @param classType Class<?> - defaults to {@link Content}
     */
    protected AbstractMagnoliaCriteriaImpl(String path, QueryManager queryManager, String itemType, Class< ? > classType)
    {
        super();
        if (StringUtils.isBlank(itemType))
        {
            this.itemType = ItemType.CONTENT.getSystemName();
        }
        else
        {
            this.itemType = itemType;
        }
        this.path = XPathTextUtils.encodeDigitsInPath(path);
        this.queryManager = queryManager;
        // defaults to info.magnolia.cms.core.Content
        this.classType = classType == null ? Content.class : classType;
    }
}